(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory();
	else if(typeof define === 'function' && define.amd)
		define("active-angular", [], factory);
	else if(typeof exports === 'object')
		exports["active-angular"] = factory();
	else
		root["active-angular"] = factory();
})(this, function() {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId])
/******/ 			return installedModules[moduleId].exports;
/******/
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// identity function for calling harmony imports with the correct context
/******/ 	__webpack_require__.i = function(value) { return value; };
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, {
/******/ 				configurable: false,
/******/ 				enumerable: true,
/******/ 				get: getter
/******/ 			});
/******/ 		}
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 4);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
function API() {

    let apiUrl = 'http://www.localhost:8000'
    let ResourceTranslator = function() {
        var split = this.split('');
        split[0] = split[0].toLowerCase();
        split = split.join("");
        return split.replace(/([A-Z])/g, function($1) {
            return "-" + $1.toLowerCase();
        });
    };

    return {


        setAPIURL: function(val) {
            apiUrl = val;
        },
        setResourceTranslator: function(fn) {
            ResourceTranslator = fn;
        },
        $get: ['$q', '$http', function($q, $http) {

            String.prototype.toDash = ResourceTranslator;

            return class API {
                constructor(Resource) {
                    this.Resource = Resource;
                    this.apiUrl = apiUrl;
                    this.resourceUrl = this.constructor._URLBuilder(Resource);
                }

                static get URL(){
                    return apiUrl
                }
                static _URLBuilder(Resource, pathData) {
                    var resource = Resource.name.split('_')[0].toDash() + 's/';
                    var args;
                    var URL = apiUrl + resource;
                    if (pathData && pathData.length > 0) { //additional url parameters are given. If resource, dashify, if not, treat as action/param.
                        for (var x = 0; x < pathData.length; x++) {
                            if (typeof(pathData[x]) == 'string' || typeof(pathData[x]) == 'number') {
                                URL = URL + pathData[x] + '/'
                            } else {
                                if (pathData[x] instanceof Function) {
                                    URL = URL + pathData[x].name.split('_')[0].toDash() + 's/'
                                } else {
                                    URL = URL + pathData[x].constructor.name.split('_')[0].toDash() + 's/';
                                    if (pathData[x].id) URL = URL + pathData[x].id + '/';

                                }
                            }
                        }
                    }
                    return URL
                }

                static _errorHandler(resourceName, $q, response) {
                    let re = /(API.\w+)/g;
                    let aRegexResult = re.exec(this.stack);
                    let methodName = aRegexResult[0] || aRegexResult[1];
                    console.error('APIService failure at method: "' + methodName + '" for resource: "' + resourceName + '\".' + '\n' + 'status: ' + response.status + ' statusText: ' + response.statusText)
                    if (typeof(response.data) == 'string') {
                        console.error(response.data)
                    } else {
                        for (var field in response.data) {
                            console.error('Error message -- ' + field + ': ' + response.data[field].toString())
                        }
                    }
                    // throw Error('test')
                    return $q.reject(response);
                }

                static _successHandler(mode, response) {
                    if (mode == 'delete') return $q.when(response)
                    return $q.when(response.data);
                }

                get(instance, args) {
                    var params = { params: args.params };
                    var pathData;
                    if (instance) { // if no instance, get hit index route instead of details route.
                        if (args.nestedResource) pathData = Array.prototype.concat.apply([], [instance.id, args.nestedResource]);
                        if (args.recursive) Object.assign(instance, args.recursive) // @@TODO@@ nestedResource should be empty if recursive is given. Check this
                        if (!instance.id) delete(instance.id)
                    }
                    var reqObj = {
                        method: 'GET',
                        url: this.constructor._URLBuilder(this.Resource, pathData),
                    }
                    Object.assign(reqObj, params);
                    return $http(reqObj).then(this.constructor._successHandler.bind(this, 'get'), this.constructor._errorHandler.bind(new Error(), this.Resource.name, $q))
                }

                create(instance, args) {
                    const params = { params: args.params };
                    var pathData;
                    if (args.nestedResource) {
                        pathData = Array.prototype.concat.apply([], [instance.id, args.nestedResource]);
                        if (args.nestedResource.id == undefined) {
                            // to cover the case where .addRelation is used on an unsaved object;
                            instance = args.nestedResource
                        }
                    }
                    if (args.recursive) Object.assign(instance, args.recursive)
                    if (!instance.id) delete(instance.id)
                    const reqObj = {
                        method: 'POST',
                        url: this.constructor._URLBuilder(this.Resource, pathData),
                        data: instance
                    }
                    Object.assign(reqObj, params);
                    return $http(reqObj)
                        .then(this.constructor._successHandler.bind(this, 'create'), this.constructor._errorHandler.bind(new Error(), this.Resource.name, $q))
                }
                delete(instance, args) {
                    const params = { params: args.params };
                    var pathData;
                    if (args.nestedResource) {
                        pathData = Array.prototype.concat.apply([], [instance.id, args.nestedResource]);
                    } else {
                        pathData = [instance.id];
                    }
                    const reqObj = {
                        method: 'DELETE',
                        url: this.constructor._URLBuilder(this.Resource, pathData)
                    }
                    Object.assign(reqObj, params);
                    return $http(reqObj)
                        .then(this.constructor._successHandler.bind(this, 'delete'), this.constructor._errorHandler.bind(new Error(), this.Resource.name, $q))

                }
                put(instance, args) {
                    const params = { params: args.params };
                    var pathData;
                    if (args.nestedResource) {
                        pathData = Array.prototype.concat.apply([], [instance.id, args.nestedResource]);
                    } else {
                        pathData = [instance.id];
                    }
                    instance = args.nestedResource || instance
                    const reqObj = {
                        method: 'PUT',
                        url: this.constructor._URLBuilder(this.Resource, pathData),
                        data: instance
                    }
                    Object.assign(reqObj, params);
                    return $http(reqObj)
                        .then(this.constructor._successHandler.bind(this, 'put'), this.constructor._errorHandler.bind(new Error(), this.Resource.name, $q))
                }
            }


        }]


    }

}


/* harmony default export */ __webpack_exports__["a"] = API;


// function API() {

//     let apiUrl = 'http://www.localhost:8000'
//     let ResourceTranslator = function() {
//         var split = this.split('');
//         split[0] = split[0].toLowerCase();
//         split = split.join("");
//         return split.replace(/([A-Z])/g, function($1) {
//             return "-" + $1.toLowerCase();
//         });
//     };

//     return {


//         setAPIURL: function(val) {
//             apiUrl = val;
//         },
//         setResourceTranslator: function(fn) {
//             ResourceTranslator = fn;
//         },
//         $get: ['$q', '$http', function($q, $http) {

//             String.prototype.toDash = ResourceTranslator;

//             return class API {
//                 constructor(Resource) {
//                     this.Resource = Resource;
//                 }

//                 static get URL(){
//                     return apiUrl
//                 }
//                 static _URLBuilder(Resource, pathData) {
//                     var resource = Resource.name.split('_')[0].toDash() + 's/';
//                     var args;
//                     var URL = apiUrl + resource;
//                     if (pathData && pathData.length > 0) { //additional url parameters are given. If resource, dashify, if not, treat as action/param.
//                         for (var x = 0; x < pathData.length; x++) {
//                             if (typeof(pathData[x]) == 'string' || typeof(pathData[x]) == 'number') {
//                                 URL = URL + pathData[x] + '/'
//                             } else {
//                                 if (pathData[x] instanceof Function) {
//                                     URL = URL + pathData[x].name.split('_')[0].toDash() + 's/'
//                                 } else {
//                                     URL = URL + pathData[x].constructor.name.split('_')[0].toDash() + 's/';
//                                     if (pathData[x].id) URL = URL + pathData[x].id + '/';

//                                 }
//                             }
//                         }
//                     }
//                     return URL
//                 }

//                 static _errorHandler(resourceName, $q, response) {
//                     let re = /(API.\w+)/g;
//                     let aRegexResult = re.exec(this.stack);
//                     let methodName = aRegexResult[0] || aRegexResult[1];
//                     console.error('APIService failure at method: "' + methodName + '" for resource: "' + resourceName + '\".' + '\n' + 'status: ' + response.status + ' statusText: ' + response.statusText)
//                     if (typeof(response.data) == 'string') {
//                         console.error(response.data)
//                     } else {
//                         for (var field in response.data) {
//                             console.error('Error message -- ' + field + ': ' + response.data[field].toString())
//                         }
//                     }
//                     return $q.reject(response);
//                 }

//                 static _successHandler(mode, response) {
//                     if (mode == 'delete') return $q.when(response)
//                     return $q.when(response.data);
//                 }

//                 get(instance, args) {
//                     var params = { params: args.params };
//                     var pathData;
//                     if (instance) { // if no instance, get hit index route instead of details route.
//                         if (args.nestedResource) pathData = Array.prototype.concat.apply([], [instance.id, args.nestedResource]);
//                         if (args.recursive) Object.assign(instance, args.recursive) // @@TODO@@ nestedResource should be empty if recursive is given. Check this
//                         if (!instance.id) delete(instance.id)
//                     }
//                     var reqObj = {
//                         method: 'GET',
//                         url: this.constructor._URLBuilder(this.Resource, pathData),
//                     }
//                     Object.assign(reqObj, params);
//                     return $http(reqObj).then(this.constructor._successHandler.bind(this, 'get'), this.constructor._errorHandler.bind(new Error(), this.Resource.name, $q))
//                 }

//                 create(instance, args) {
//                     const params = { params: args.params };
//                     var pathData;
//                     if (args.nestedResource) {
//                         pathData = Array.prototype.concat.apply([], [instance.id, args.nestedResource]);
//                         if (args.nestedResource.id == undefined) {
//                             // to cover the case where .addRelation is used on an unsaved object;
//                             instance = args.nestedResource
//                         }
//                     }
//                     if (args.recursive) Object.assign(instance, args.recursive)
//                     if (!instance.id) delete(instance.id)
//                     const reqObj = {
//                         method: 'POST',
//                         url: this.constructor._URLBuilder(this.Resource, pathData),
//                         data: instance
//                     }
//                     Object.assign(reqObj, params);
//                     return $http(reqObj)
//                         .then(this.constructor._successHandler.bind(this, 'create'), this.constructor._errorHandler.bind(new Error(), this.Resource.name, $q))
//                 }
//                 delete(instance, args) {
//                     const params = { params: args.params };
//                     var pathData;
//                     if (args.nestedResource) {
//                         pathData = Array.prototype.concat.apply([], [instance.id, args.nestedResource]);
//                     } else {
//                         pathData = [instance.id];
//                     }
//                     const reqObj = {
//                         method: 'DELETE',
//                         url: this.constructor._URLBuilder(this.Resource, pathData)
//                     }
//                     Object.assign(reqObj, params);
//                     return $http(reqObj)
//                         .then(this.constructor._successHandler.bind(this, 'delete'), this.constructor._errorHandler.bind(new Error(), this.Resource.name, $q))

//                 }
//                 put(instance, args) {
//                     const params = { params: args.params };
//                     var pathData;
//                     if (args.nestedResource) {
//                         pathData = Array.prototype.concat.apply([], [instance.id, args.nestedResource]);
//                     } else {
//                         pathData = [instance.id];
//                     }
//                     instance = args.nestedResource || instance
//                     const reqObj = {
//                         method: 'PUT',
//                         url: this.constructor._URLBuilder(this.Resource, pathData),
//                         data: instance
//                     }
//                     Object.assign(reqObj, params);
//                     return $http(reqObj)
//                         .then(this.constructor._successHandler.bind(this, 'put'), this.constructor._errorHandler.bind(new Error(), this.Resource.name, $q))
//                 }
//             }


//         }]


//     }

// }


// export default API


/***/ }),
/* 1 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
function Base($q, API, RelationCollection) {


    return class Base {

        static factory(args) {
            args = Array.prototype.concat.apply([], [args])
            return args.map(function(inst, i) {
                return new this(inst);
            }, this)
        }
        static byId(args) {
            var match = false;
            for (var i = 0; i < this.list.length; i++) {
                if (this.list[i].id == args) {
                    match = this.list[i];
                    break;
                }
            }
            return match;
        }

        static get(args) {
            function defaultCallback(response) {

                var instances = this.factory(response)
                this.alreadyFetched = true;
                return $q.when(instances)
            }
            args = args || {};
            return this.API.get(null, args).then(defaultCallback.bind(this));
        }

        static sort(target, type) {
            this.list.sort(function(x, y) {
                if (target == 'id') {
                    if (type == 'desc') {
                        let c = x;
                        x = y;
                        y = c;
                    }
                    return x.id - y.id
                }
                if (target == 'name') {
                    if (type == 'desc') {
                        let c = x;
                        x = y;
                        y = c;
                    }
                    return x.id - y.id
                }
            })
        }

        static map(attr) {
            var _createVariableMapping = this._createVariableMapping.bind(this, attr);
            return { to: _createVariableMapping };
        }
        static relate(attr) {
            var _createRelation = this._createRelation.bind(this, attr);
            return { to: _createRelation };
        }

        get(args) {
            var instance = this;
            // var requestInstance = this.constructor._preprocessOutgoing(this); no preprocess outgoing needed; only ID.
            function defaultCallback(response) {
                instance.id = response.id;
                return $q.when(instance);
            }
            args = args || {};
            if (args.nestedResource && !args.callBack || args.recursive && !args.callBack) {
                throw new NoCallBackError()
            }
            return this.constructor.API.get(instance, args).then(args.callBack || defaultCallback.bind(this));
        }

        save(args) {
            var instance = this;
            var requestInstance = this.constructor._preprocessOutgoing(this);

            function defaultCallback(response) {
                instance.id = response.id
                this.constructor._add(this)
                return $q.when(instance)
            }
            args = args || {};
            if (args.nestedResource && !args.callBack || args.recursive && !args.callBack) {
                throw new NoCallBackError()
            }
            
            // if (args.recursive) debugger;
            return this.constructor.API.create(requestInstance, args).then(args.callBack || defaultCallback.bind(this));
        }

        delete(args) {
            function defaultCallback(instance) {
                instance = this;
                let j = this.constructor.list.findIndex(iterator => iterator.id == instance.id);
                if (j > -1) {
                    this.constructor.list.splice(j, 1);
                }
                return $q.when(instance);
            }
            args = args || {};
            if (args.nestedResource && !args.callBack) {
                throw new NoCallBackError()
            }
            return this.constructor.API.delete(this, args).then(args.callBack || defaultCallback.bind(this))
        }
        put(args) {
            var instance = this;
            var requestInstance = this.constructor._preprocessOutgoing(this);

            function defaultCallback(response) {
                let instance = new this.constructor(response); // if id is not unique, overwrite list entry
                // @@TODO@@ compare every field;
                return $q.when(instance);
            }
            args = args || {};
            if (args.nestedResource && !args.callBack) {
                throw new NoCallBackError()
            }
            return this.constructor.API.put(requestInstance, args).then(args.callBack || defaultCallback.bind(this))
        }
        static _add(instance) { // internally add to .list list
            if (instance.id) { // only saved objects (i.e. with id), should be added to the list
                var notUnique = false
                for (var n = 0; n < this.list.length; n++) {
                    if (this.list[n].id == instance.id) {
                        notUnique = true;
                        break;
                    }
                }
                if (notUnique) {
                    this.list[n] = instance;
                } else {
                    this.list.unshift(instance)
                }
            }
        }
        static _setStaticVars(Resource) {
            if (!Resource.API) Resource.API = new API(Resource);
            if (!Resource.list) Resource.list = [];
            if (!Resource._relations) Resource._relations = {};
            // if (!Resource._recursiveRelations) Resource._recursiveRelations = {};
            if (!Resource._variableMapping) Resource._variableMapping = { _inverse: {} };
            if (!Resource.dataTemplate) Resource.dataTemplate = { 'id': 'optional' };
        }


        static _createVariableMapping(attr, target) {
            this._variableMapping[attr] = target;
            this._variableMapping._inverse[target] = attr;
        }
        static _createRelation(attr, targetResource, options) {
            this._relations[attr] = { resource: targetResource, recursive: false };
            if (options && options.recursive) {
                if (options.recursive === true) {
                    this._relations[attr].recursive = 'parentId'
                } else {
                    this._relations[attr].recursive = options.recursive
                }
            }
        }
        _createRelationCollectionFor(targetResource, items) {
            let _relationSettings;
            for (let label in this.constructor._relations) {
                if (this.constructor._relations[label].resource === targetResource) {
                    _relationSettings = this.constructor._relations[label];
                    break;
                }
            }
            return new RelationCollection(this, _relationSettings, items)
        }
        static setDataTemplate(keys) {
            for (var i = 0; i < keys.length; i++) {
                this.dataTemplate[keys[i]] = 'required';
            }
        }
        static _preprocessOutgoing(instance) {
            var data = {};
            for (var attr in this.dataTemplate) {
                if (this._variableMapping.hasOwnProperty(attr)) {
                    data[attr] = instance[this._variableMapping[attr]] || null
                } else {
                    data[attr] = instance[attr] || null
                }
            }
            return data;
        }
        static _preprocessIncoming(data) {
            var preprocessedData = [];
            var varMap = this._variableMapping;
            data = Array.prototype.concat.apply([], [data])
            for (var i = 0; i < data.length; i++) {
                var preprocessedRawInstance = {}
                var rawInstance = data[i];
                for (var attr in this.dataTemplate) {
                    if (!rawInstance.hasOwnProperty(attr) && this.dataTemplate[attr] == 'required') {
                        if (rawInstance.hasOwnProperty(this._variableMapping[attr])) {
                            rawInstance[attr] = rawInstance[this._variableMapping[attr]]
                        } else {
                            throw Error('Expecting raw instance input to include key "' + attr + '", but it was not found (' + this.name + ')')
                        }
                    }
                    if (Object.getOwnPropertyNames(varMap).length > 1 && varMap.hasOwnProperty(attr)) {
                        preprocessedRawInstance[varMap[attr]] = rawInstance[attr];
                    } else {
                        preprocessedRawInstance[attr] = rawInstance[attr];
                    }
                    if (this._relations.hasOwnProperty(attr) && !!preprocessedRawInstance[attr]) preprocessedRawInstance[attr] = this._relations[attr].resource._preprocessIncoming(rawInstance[attr]);

                }
                preprocessedData.push(preprocessedRawInstance);
            }
            // @@TODO@@ throw error when there are keys from api response that are not in this.keys
            if (preprocessedData.length == 1) return preprocessedData[0];
            return preprocessedData;
        }
    }


}



/* harmony default export */ __webpack_exports__["a"] = Base;


/***/ }),
/* 2 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
function generator(API, Base) {


    function parseOptions(customLogic) {
        customLogic.instanceMethods = customLogic.instanceMethods || []
        customLogic.staticMethods = customLogic.staticMethods || []
        customLogic.staticVars = customLogic.staticVars || {}
        if (customLogic.constructor.name != 'constructor') customLogic.constructor = function() {}
    }

    function generator(resourceName, keys, customLogic) {
        if (!keys) throw Error('No keys given for resource ' + resourceName);
        if (keys.constructor != Array) throw Error('Keys for ' + resourceName + ' must be passed as an Array of strings');


        customLogic = customLogic || {}
        parseOptions(customLogic);
        var instanceMethods = Array.prototype.concat.call([], customLogic.instanceMethods);
        var staticMethods = Array.prototype.concat.call([], customLogic.staticMethods);
        var staticVars = customLogic.staticVars

        var _ormClass = {
            [resourceName]: class {
                constructor(args) {
                    args = this.constructor._preprocessIncoming(args)
                    var relations = this.constructor._relations;
                    for (var attr in args) {
                        this[attr] = args[attr]
                    };
                    if (relations) {
                        for (var attr in this) {
                            if (relations.hasOwnProperty(attr)) {
                                let Constructor = relations[attr].resource
                                if (this[attr] == null) {
                                    this[attr] = this._createRelationCollectionFor(Constructor, [])
                                } else {
                                    this[attr] = this._createRelationCollectionFor(Constructor, Constructor.factory(args[attr]))
                                }
                            }
                        }
                    }
                    this.constructor._add(this)
                    let returner
                    try {
                        returner = customLogic.constructor.bind(this)() || this
                    } catch (err) {
                        debugger
                    }
                    return returner
                }
            }
        }
        var Resource = _ormClass[resourceName];

        Object.setPrototypeOf(Resource.prototype, Base.prototype);
        Object.setPrototypeOf(Resource, Base);
        for (var i = 0; i < instanceMethods.length; i++) Resource.prototype[instanceMethods[i].name] = instanceMethods[i];
        for (var i = 0; i < staticMethods.length; i++) Resource[staticMethods[i].name] = staticMethods[i];
        for (var attr in staticVars) Resource[attr] = staticVars[attr];
        Resource._setStaticVars(Resource);
        Resource.setDataTemplate(keys);
        return Resource
    }

    return generator

}
/* harmony default export */ __webpack_exports__["a"] = generator;


/***/ }),
/* 3 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
function RelationCollection($q) {

    return class RelationCollection {
        constructor(hostInstance, relationSettings, items) {

            let collection = []
            collection._hostInstance = hostInstance;
            collection._relationSettings = relationSettings;

            collection.deleteRelation = this.deleteRelation;
            collection.addRelation = this.addRelation;
            collection._getAndAddToCollection = this._getAndAddToCollection;
            collection.get = this.get;



            collection._constructor = this.constructor
            if (items) {
                items.forEach(function(item, index) {
                    collection.push(item)
                })
            }
            this.collection = collection
            return this.collection;
        }

        get(args) {
            var reqOptn = {
                nestedResource: this._relationSettings.resource,
                callBack: this._getAndAddToCollection.bind(this),
                params: {}
            }
            Object.assign(reqOptn, args)
            return this._hostInstance.get(reqOptn)
        }

        deleteRelation(instance, args) {
            args = args || {}
            // @@TODO support recursive delete
                return this._hostInstance.delete({
                    nestedResource: instance,
                    callBack: this._constructor._removeFromCollection.bind(this, instance)
                }, args)
            }
            // @@TODO support arbitrarly nested relations; <-- I think this is included already by good design =)
        addRelation(instance, args) {
            args = args || {}
            const reqOptn = {
                callBack: this._constructor._addToCollection.bind(this, instance)
            }
            Object.assign(reqOptn, args)
            if (this._relationSettings.recursive) {
                reqOptn.recursive = {};
                reqOptn.recursive[this._relationSettings.recursive] = this._hostInstance.id
                return instance.save(reqOptn)
            } else {
                // if instance has an ID, we're assuming that both the host instance and nested instance are pre-existing, and we interpret it as creating a relation.
                // if instance has no ID, we're assuming that user wants to save nested instance and add it to host instance relation. In this case, save intance and let backend handle the relation adding.
                // (this is not handled here, but further down in api.js) 
                reqOptn.nestedResource = instance;
                return this._hostInstance.save(reqOptn)
            }
        }

        _getAndAddToCollection(response) {
            let instances = this._relationSettings.resource.factory(response);
            Array.prototype.push.apply(this, instances)
            return $q.when();
        }

        static _createAndAddToCollection(instance) {
            instance.id;
            this.push(instance)
            return $q.when(instance);
        }
        static _addToCollection(instance, response) {
            if (response && response.id){
                instance.id = response.id
            }
            this.push(instance)
            instance._rawResponse = response; // change return value of promise into {instance: .., rawResponse: ...}. However this is not backwards compatible, will break scipost probably. 
            return $q.when(instance);
        }
        static _removeFromCollection(instance) {
            for (var n = 0; n < this.length; n++) {
                if (this[n].id == instance.id) {
                    this.splice(n, 1);
                    break;
                }
            }
            return $q.when();
        }
    }
}

/* harmony default export */ __webpack_exports__["a"] = RelationCollection;


/***/ }),
/* 4 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
Object.defineProperty(__webpack_exports__, "__esModule", { value: true });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__api_js__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__relation_collection_js__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__base_js__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__generator_js__ = __webpack_require__(2);






const activeAngular = angular.module('active-angular', [])

activeAngular
  .provider('API', __WEBPACK_IMPORTED_MODULE_0__api_js__["a" /* default */])
  .factory('RelationCollection', __WEBPACK_IMPORTED_MODULE_1__relation_collection_js__["a" /* default */])
  .factory('Base', __WEBPACK_IMPORTED_MODULE_2__base_js__["a" /* default */])
  .factory('activeAngularResource', __WEBPACK_IMPORTED_MODULE_3__generator_js__["a" /* default */])


/* harmony default export */ __webpack_exports__["default"] = activeAngular.name;

/***/ })
/******/ ]);
});