function generator(API, Base) {


    function parseOptions(customLogic) {
        customLogic.instanceMethods = customLogic.instanceMethods || []
        customLogic.staticMethods = customLogic.staticMethods || []
        customLogic.staticVars = customLogic.staticVars || {}
        if (customLogic.constructor.name != 'constructor') customLogic.constructor = function() {}
    }

    function generator(resourceName, keys, customLogic) {
        if (!keys) throw Error('No keys given for resource ' + resourceName);
        if (keys.constructor != Array) throw Error('Keys for ' + resourceName + ' must be passed as an Array of strings');


        customLogic = customLogic || {}
        parseOptions(customLogic);
        var instanceMethods = Array.prototype.concat.call([], customLogic.instanceMethods);
        var staticMethods = Array.prototype.concat.call([], customLogic.staticMethods);
        var staticVars = customLogic.staticVars

        var _ormClass = {
            [resourceName]: class {
                constructor(args) {
                    args = this.constructor._preprocessIncoming(args)
                    var relations = this.constructor._relations;
                    for (var attr in args) {
                        this[attr] = args[attr]
                    };
                    if (relations) {
                        for (var attr in this) {
                            if (relations.hasOwnProperty(attr)) {
                                let Constructor = relations[attr].resource
                                if (this[attr] == null) {
                                    this[attr] = this._createRelationCollectionFor(Constructor, [])
                                } else {
                                    this[attr] = this._createRelationCollectionFor(Constructor, Constructor.factory(args[attr]))
                                }
                            }
                        }
                    }
                    this.constructor._add(this)
                    let returner
                    try {
                        returner = customLogic.constructor.bind(this)() || this
                    } catch (err) {
                        debugger
                    }
                    return returner
                }
            }
        }
        var Resource = _ormClass[resourceName];

        Object.setPrototypeOf(Resource.prototype, Base.prototype);
        Object.setPrototypeOf(Resource, Base);
        for (var i = 0; i < instanceMethods.length; i++) Resource.prototype[instanceMethods[i].name] = instanceMethods[i];
        for (var i = 0; i < staticMethods.length; i++) Resource[staticMethods[i].name] = staticMethods[i];
        for (var attr in staticVars) Resource[attr] = staticVars[attr];
        Resource._setStaticVars(Resource);
        Resource.setDataTemplate(keys);
        return Resource
    }

    return generator

}
export default generator
