function RelationCollection($q) {

    return class RelationCollection {
        constructor(hostInstance, relationSettings, items) {

            let collection = []
            collection._hostInstance = hostInstance;
            collection._relationSettings = relationSettings;

            collection.deleteRelation = this.deleteRelation;
            collection.addRelation = this.addRelation;
            collection._getAndAddToCollection = this._getAndAddToCollection;
            collection.get = this.get;



            collection._constructor = this.constructor
            if (items) {
                items.forEach(function(item, index) {
                    collection.push(item)
                })
            }
            this.collection = collection
            return this.collection;
        }

        get(args) {
            var reqOptn = {
                nestedResource: this._relationSettings.resource,
                callBack: this._getAndAddToCollection.bind(this),
                params: {}
            }
            Object.assign(reqOptn, args)
            return this._hostInstance.get(reqOptn)
        }

        deleteRelation(instance, args) {
            args = args || {}
            // @@TODO support recursive delete
                return this._hostInstance.delete({
                    nestedResource: instance,
                    callBack: this._constructor._removeFromCollection.bind(this, instance)
                }, args)
            }
            // @@TODO support arbitrarly nested relations; <-- I think this is included already by good design =)
        addRelation(instance, args) {
            args = args || {}
            const reqOptn = {
                callBack: this._constructor._addToCollection.bind(this, instance)
            }
            Object.assign(reqOptn, args)
            if (this._relationSettings.recursive) {
                reqOptn.recursive = {};
                reqOptn.recursive[this._relationSettings.recursive] = this._hostInstance.id
                return instance.save(reqOptn)
            } else {
                // if instance has an ID, we're assuming that both the host instance and nested instance are pre-existing, and we interpret it as creating a relation.
                // if instance has no ID, we're assuming that user wants to save nested instance and add it to host instance relation. In this case, save intance and let backend handle the relation adding.
                // (this is not handled here, but further down in api.js) 
                reqOptn.nestedResource = instance;
                return this._hostInstance.save(reqOptn)
            }
        }

        _getAndAddToCollection(response) {
            let instances = this._relationSettings.resource.factory(response);
            Array.prototype.push.apply(this, instances)
            return $q.when();
        }

        static _createAndAddToCollection(instance) {
            instance.id;
            this.push(instance)
            return $q.when(instance);
        }
        static _addToCollection(instance, response) {
            if (response && response.id){
                instance.id = response.id
            }
            this.push(instance)
            instance._rawResponse = response; // change return value of promise into {instance: .., rawResponse: ...}. However this is not backwards compatible, will break scipost probably. 
            return $q.when(instance);
        }
        static _removeFromCollection(instance) {
            for (var n = 0; n < this.length; n++) {
                if (this[n].id == instance.id) {
                    this.splice(n, 1);
                    break;
                }
            }
            return $q.when();
        }
    }
}

export default RelationCollection
