/*global __dirname, require, module*/

const webpack = require('webpack');
const path = require('path');
const env = require('yargs').argv.env; // use --env with webpack 2
const RemoveSourceMapUrlWebpackPlugin = require('@rbarilani/remove-source-map-url-webpack-plugin');
const removeSourceMapping = new RemoveSourceMapUrlWebpackPlugin({test: /active-angular\.js$/})
let libraryName = 'active-angular';

let plugins = [removeSourceMapping]

const config = {
    entry: __dirname + '/src/index.js',
    output: {
        path: __dirname + '/lib',
        filename: libraryName+'.js',
        library: libraryName,
        libraryTarget: 'umd',
        umdNamedDefine: true
    },
    module: {
        // rules: [{
        //     test: /(\.jsx|\.js)$/,
        //     loader: 'babel-loader',
        //     exclude: /(node_modules|bower_components)/,
        //     query: {
        //         presets: ["latest"]
        //     }
        // }]
    },
    resolve: {
        modules: [path.resolve('./src')],
        extensions: ['.json', '.js']
    },
    plugins: plugins,
    externals: {
        angular: 'angular'
    }
};

module.exports = config;
